## libpdb-redo 3.3.0

=== CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause

# Copyright (c) 2021 NKI/AVL, Netherlands Cancer Institute

# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:

# 1. Redistributions of source code must retain the above copyright notice, this
# list of conditions and the following disclaimer
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.16)

# set the project name
project(libpdb-redo VERSION 3.3.0 LANGUAGES CXX C)

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

include(GNUInstallDirs)
include(CheckFunctionExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CMakePackageConfigHelpers)
include(CheckCXXSourceCompiles)
include(FindOrFetch)
include(GenerateExportHeader)
include(CTest)

set(CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers")
elseif(MSVC)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
endif()

# Building shared libraries?
option(BUILD_SHARED_LIBS "Build a shared library instead of a static one" OFF)

# We do not want to write an export file for all our symbols...
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

# Optionally build a version to be installed inside CCP4
option(BUILD_FOR_CCP4 "Build a version to be installed in CCP4" OFF)

# Optionally leave out the minimizer
option(BUILD_MINIMIZER "Build the minimizer code" ON)

if(BUILD_FOR_CCP4)
	if("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4})
		message(FATAL_ERROR "A CCP4 built was requested but CCP4 was not sourced")
	else()
		list(APPEND CMAKE_MODULE_PATH "$ENV{CCP4}")
		list(APPEND CMAKE_PREFIX_PATH "$ENV{CCP4}")
		set(CMAKE_INSTALL_PREFIX "$ENV{CCP4}")

		# This is the only option:
		if(WIN32)
			set(BUILD_SHARED_LIBS ON)
		endif()
	endif("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4})
endif()

# Check if CCP4 is available
if(EXISTS "$ENV{CCP4}")
	set(CCP4 $ENV{CCP4})
	set(CLIBD ${CCP4}/lib/data)
endif()

if(CCP4 AND NOT CLIBD)
	set(CLIBD ${CCP4}/lib/data)
endif()

if(MSVC)
	# make msvc standards compliant...
	add_compile_options(/permissive-)
	add_link_options(/NODEFAULTLIB:library)

	macro(get_WIN32_WINNT version)
		if(WIN32 AND CMAKE_SYSTEM_VERSION)
			set(ver ${CMAKE_SYSTEM_VERSION})
			string(REPLACE "." "" ver ${ver})
			string(REGEX REPLACE "([0-9])" "0\\1" ver ${ver})

			set(${version} "0x${ver}")
		endif()
	endmacro()

	get_WIN32_WINNT(ver)
	add_definitions(-D_WIN32_WINNT=${ver})
endif()

# Libraries
find_package(Eigen3 REQUIRED)
find_package(CCP4 REQUIRED ccp4c clipper-core clipper-ccp4 clipper-contrib)
find_package(GSL REQUIRED)

if(NOT (cifpp_FOUND OR TARGET cifpp))
	find_or_fetch_package(cifpp VERSION 7.0.9 GIT_REPOSITORY https://github.com/PDB-REDO/libcifpp.git GIT_TAG v7.0.9 VARIABLES "CIFPP_SHARE_DIR")
endif()

# Create a revision file, containing the current git version info
include(VersionString)
write_version_header("${PROJECT_SOURCE_DIR}/src" LIB_NAME "LibPDBREDO")

# Sources
list(APPEND project_sources
	${PROJECT_SOURCE_DIR}/src/AtomShape.cpp
	${PROJECT_SOURCE_DIR}/src/BondMap.cpp
	${PROJECT_SOURCE_DIR}/src/ClipperWrapper.cpp
	${PROJECT_SOURCE_DIR}/src/Compound.cpp
	${PROJECT_SOURCE_DIR}/src/DistanceMap.cpp
	${PROJECT_SOURCE_DIR}/src/MapMaker.cpp
	${PROJECT_SOURCE_DIR}/src/Ramachandran.cpp
	${PROJECT_SOURCE_DIR}/src/ResolutionCalculator.cpp
	${PROJECT_SOURCE_DIR}/src/SkipList.cpp
	${PROJECT_SOURCE_DIR}/src/Statistics.cpp
	${PROJECT_SOURCE_DIR}/src/TLS.cpp
	${PROJECT_SOURCE_DIR}/src/Version.cpp
)

list(APPEND project_headers
	${PROJECT_SOURCE_DIR}/include/pdb-redo/AtomShape.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/BondMap.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/ClipperWrapper.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/Compound.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/DistanceMap.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/MapMaker.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/Ramachandran.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/ResolutionCalculator.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/SkipList.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/Statistics.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/TLS.hpp
	${PROJECT_SOURCE_DIR}/include/pdb-redo/Version.hpp
)

if(BUILD_MINIMIZER)
	list(APPEND project_sources
		${PROJECT_SOURCE_DIR}/src/Minimizer.cpp
		${PROJECT_SOURCE_DIR}/src/Restraints.cpp
	)

	list(APPEND project_headers
		${PROJECT_SOURCE_DIR}/include/pdb-redo/Minimizer.hpp
		${PROJECT_SOURCE_DIR}/include/pdb-redo/Restraints.hpp
	)
endif()

add_library(pdb-redo ${project_sources} ${project_headers})
add_library(pdb-redo::pdb-redo ALIAS pdb-redo)
set_target_properties(pdb-redo PROPERTIES POSITION_INDEPENDENT_CODE ON)
generate_export_header(pdb-redo EXPORT_FILE_NAME ${PROJECT_SOURCE_DIR}/include/pdb-redo/exports.hpp)

target_include_directories(pdb-redo
	PUBLIC
	"$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>"
	"$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
	${CCP4_INCLUDE_DIRS})
target_link_libraries(pdb-redo PUBLIC cifpp::cifpp GSL::gsl ${CCP4_LIBRARIES})
target_include_directories(pdb-redo PRIVATE ${EIGEN3_INCLUDE_DIR})

if(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
	target_link_options(pdb-redo PRIVATE -undefined dynamic_lookup)
endif(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")

set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR})
set(LIBRARY_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR})

# Install rules
install(TARGETS pdb-redo
	EXPORT pdb-redoTargets
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

install(EXPORT pdb-redoTargets
	FILE "pdb-redoTargets.cmake"
	NAMESPACE pdb-redo::
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/pdb-redo
)

install(
	DIRECTORY include/pdb-redo
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
	COMPONENT Devel
)

configure_package_config_file(${PROJECT_SOURCE_DIR}/cmake/pdb-redoConfig.cmake.in
	${CMAKE_CURRENT_BINARY_DIR}/pdb-redo/pdb-redoConfig.cmake
	INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/pdb-redo
	PATH_VARS INCLUDE_INSTALL_DIR LIBRARY_INSTALL_DIR
)

install(FILES
	"${CMAKE_CURRENT_BINARY_DIR}/pdb-redo/pdb-redoConfig.cmake"
	"${CMAKE_CURRENT_BINARY_DIR}/pdb-redo/pdb-redoConfigVersion.cmake"
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/pdb-redo
	COMPONENT Devel
)

set_target_properties(pdb-redo PROPERTIES
	VERSION ${PROJECT_VERSION}
	SOVERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}"
	INTERFACE_pdb-redo_MAJOR_VERSION ${PROJECT_VERSION_MAJOR})

set_property(TARGET pdb-redo APPEND PROPERTY
	COMPATIBLE_INTERFACE_STRING pdb-redo_MAJOR_VERSION
)

write_basic_package_version_file(
	"${CMAKE_CURRENT_BINARY_DIR}/pdb-redo/pdb-redoConfigVersion.cmake"
	VERSION ${PROJECT_VERSION}
	COMPATIBILITY AnyNewerVersion
)

# pkgconfig support
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(libdir ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})
set(includedir ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR})

configure_file(${PROJECT_SOURCE_DIR}/cmake/libpdb-redo.pc.in
	${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc.in @ONLY)
file(GENERATE OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc
	INPUT ${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc.in)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

if(BUILD_TESTING AND NOT MSVC AND PROJECT_IS_TOP_LEVEL)
	add_subdirectory(test)
endif()

# Tarball generation
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE")
set(CPACK_SOURCE_TGZ ON)
set(CPACK_SOURCE_TBZ2 OFF)
set(CPACK_SOURCE_TXZ OFF)
set(CPACK_SOURCE_TZ OFF)
set(CPACK_SOURCE_IGNORE_FILES "/data/components.cif;/build;/.vscode;/.git;/regex/doc;/regex/example;/regex/meta;/regex/performance;/regex/test")
set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${CPACK_PACKAGE_FILE_NAME})
include(CPack)

=== examples/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause

# Copyright (c) 2021 NKI/AVL, Netherlands Cancer Institute

# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:

# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.16)

# set the project name
project(pdb-redo-example VERSION 3.1.5 LANGUAGES CXX C)

set(CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(MSVC)
    # make msvc standards compliant...
    add_compile_options(/permissive-)
	add_link_options(/NODEFAULTLIB:library)

	macro(get_WIN32_WINNT version)
		if (WIN32 AND CMAKE_SYSTEM_VERSION)
			set(ver ${CMAKE_SYSTEM_VERSION})
			string(REPLACE "." "" ver ${ver})
			string(REGEX REPLACE "([0-9])" "0\\1" ver ${ver})

			set(${version} "0x${ver}")
		endif()
	endmacro()

	get_WIN32_WINNT(ver)
	add_definitions(-D_WIN32_WINNT=${ver})
endif()

# Libraries
find_package(CCP4 REQUIRED ccp4c clipper-core clipper-ccp4 clipper-contrib)

if(NOT TARGET pdb-redo)
	find_package(pdb-redo ${PROJECT_VERSION} REQUIRED)
endif()

add_executable(pdb-redo-example example.cpp)
target_link_libraries(pdb-redo-example pdb-redo::pdb-redo)

enable_testing()

add_test(NAME pdb-redo-example
	COMMAND $<TARGET_FILE:pdb-redo-example>
	WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})

=== test/CMakeLists.txt ===
find_package(Catch2 3 QUIET)

if(NOT Catch2_FOUND)
	include(FetchContent)

	FetchContent_Declare(
		Catch2
		GIT_REPOSITORY https://github.com/catchorg/Catch2.git
		GIT_TAG GIT_TAG v3.5.2)

	FetchContent_MakeAvailable(Catch2)
endif()

list(APPEND PDB_REDO_tests pdb-redo-unit restr2ccd)
if(BUILD_MINIMIZER)
	list(APPEND PDB_REDO_tests rsr)
endif()

foreach(PDB_REDO_TEST IN LISTS PDB_REDO_tests)
	set(PDB_REDO_TEST "${PDB_REDO_TEST}-test")
	set(PDB_REDO_TEST_SOURCE "${PROJECT_SOURCE_DIR}/test/${PDB_REDO_TEST}.cpp")

	add_executable(${PDB_REDO_TEST} ${PDB_REDO_TEST_SOURCE})
	target_link_libraries(${PDB_REDO_TEST} PRIVATE pdb-redo Catch2::Catch2)

	if(MSVC)
		# Specify unwind semantics so that MSVC knowns how to handle exceptions
		target_compile_options(${PDB_REDO_TEST} PRIVATE /EHsc)
	endif()

	add_custom_target("run-${PDB_REDO_TEST}" DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Run${PDB_REDO_TEST}.touch ${PDB_REDO_TEST})

	add_custom_command(
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Run${PDB_REDO_TEST}.touch
		COMMAND $<TARGET_FILE:${PDB_REDO_TEST}> -- ${PROJECT_SOURCE_DIR}/test)

	add_test(NAME ${PDB_REDO_TEST}
		COMMAND $<TARGET_FILE:${PDB_REDO_TEST}> --data-dir ${PROJECT_SOURCE_DIR}/test)
endforeach()

=== debian/changelog ===
libpdb-redo (3.3.0-2) unstable; urgency=medium

  * Fix upload

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sun, 07 Sep 2025 10:07:31 +0200

libpdb-redo (3.3.0-1) unstable; urgency=medium

  * New upstream version
  * Closes: #1101924

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 02 Apr 2025 13:07:03 +0200

libpdb-redo (3.2.1-2) unstable; urgency=medium

  * update package name due to changed SONAME

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 29 Jan 2025 11:58:38 +0100

=== debian/control ===
Source: libpdb-redo
Section: libs
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
Build-Depends:
 debhelper-compat (= 13),
 libcifpp-dev (>= 7),
 cmake,
 libcatch2-dev,
 pkgconf,
 libgsl-dev,
 libboost-regex-dev,
 libeigen3-dev,
 libclipper-dev,
 zlib1g-dev,
 libccp4-dev (>= 6.5.1-5)
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/med-team/libpdb-redo
Vcs-Git: https://salsa.debian.org/med-team/libpdb-redo.git
Homepage: https://github.com/PDB-REDO/libpdb-redo
Rules-Requires-Root: no

Package: libpdb-redo-dev
Section: libdevel
Architecture: any
Depends:
 libpdb-redo3.3 (= ${binary:Version}),
 libclipper-dev,
 zlib1g-dev,
 libgsl-dev,
 libcifpp-dev,
 ${misc:Depends},
Description: Development files for libpdb-redo
 This library contains shared code for the various programs
 in the project PDB-REDO.
 .
 This specific package contains all files needed to develop new
 software using libpdb-redo.

Package: libpdb-redo3.3
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Library file for libpdb-redo
 This library contains shared code for the various programs
 in the project PDB-REDO.
 .
 This package contains the shared library for libpdb-redo.

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON -DPDB_REDO_BUILD_TESTS=ON -DBUILD_MINIMIZER=OFF

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, @builddeps@, mrc
Restrictions: allow-stderr

=== debian/watch ===
version=4

#  - when using releases:
# opts="filenamemangle=s%(?:.*?)?v(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
#   https://github.com/PDB-REDO/libpdb-redo/releases/latest .*/archive/v@ANY_VERSION@\.tar\.gz
#  - when using tags
opts="filenamemangle=s%(?:.*?)?v(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/PDB-REDO/libpdb-redo/tags .*/v@ANY_VERSION@\.tar\.gz

## libpdb-redo 3.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 cmake_minimum_required(VERSION 3.16)
 
 # set the project name
-project(libpdb-redo VERSION 3.3.0 LANGUAGES CXX C)
+project(libpdb-redo VERSION 3.3.1 LANGUAGES CXX C)
 
 list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
 
@@ -35,7 +35,7 @@
 include(CheckLibraryExists)
 include(CMakePackageConfigHelpers)
 include(CheckCXXSourceCompiles)
-include(FindOrFetch)
+include(CPM)
 include(GenerateExportHeader)
 include(CTest)
 
@@ -63,7 +63,7 @@
 
 if(BUILD_FOR_CCP4)
 	if("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4})
-		message(FATAL_ERROR "A CCP4 built was requested but CCP4 was not sourced")
+		message(FATAL_ERROR "pdb-redo: A CCP4 built was requested but CCP4 was not sourced")
 	else()
 		list(APPEND CMAKE_MODULE_PATH "$ENV{CCP4}")
 		list(APPEND CMAKE_PREFIX_PATH "$ENV{CCP4}")
@@ -110,9 +110,11 @@
 find_package(CCP4 REQUIRED ccp4c clipper-core clipper-ccp4 clipper-contrib)
 find_package(GSL REQUIRED)
 
-if(NOT (cifpp_FOUND OR TARGET cifpp))
-	find_or_fetch_package(cifpp VERSION 7.0.9 GIT_REPOSITORY https://github.com/PDB-REDO/libcifpp.git GIT_TAG v7.0.9 VARIABLES "CIFPP_SHARE_DIR")
-endif()
+CPMFindPackage(
+	NAME cifpp
+	GIT_REPOSITORY https://github.com/PDB-REDO/libcifpp.git
+	VERSION 9.0.5
+)
 
 # Create a revision file, containing the current git version info
 include(VersionString)
@@ -121,6 +123,7 @@
 # Sources
 list(APPEND project_sources
 	${PROJECT_SOURCE_DIR}/src/AtomShape.cpp
+	${PROJECT_SOURCE_DIR}/src/BlobFinder.cpp
 	${PROJECT_SOURCE_DIR}/src/BondMap.cpp
 	${PROJECT_SOURCE_DIR}/src/ClipperWrapper.cpp
 	${PROJECT_SOURCE_DIR}/src/Compound.cpp
@@ -136,6 +139,7 @@
 
 list(APPEND project_headers
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/AtomShape.hpp
+	${PROJECT_SOURCE_DIR}/include/pdb-redo/BlobFinder.hpp
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/BondMap.hpp
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/ClipperWrapper.hpp
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/Compound.hpp
@@ -153,11 +157,13 @@
 	list(APPEND project_sources
 		${PROJECT_SOURCE_DIR}/src/Minimizer.cpp
 		${PROJECT_SOURCE_DIR}/src/Restraints.cpp
+		${PROJECT_SOURCE_DIR}/src/ShapeFitter.cpp
 	)
 
 	list(APPEND project_headers
 		${PROJECT_SOURCE_DIR}/include/pdb-redo/Minimizer.hpp
 		${PROJECT_SOURCE_DIR}/include/pdb-redo/Restraints.hpp
+		${PROJECT_SOURCE_DIR}/include/pdb-redo/ShapeFitter.hpp
 	)
 endif()

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 	FetchContent_MakeAvailable(Catch2)
 endif()
 
-list(APPEND PDB_REDO_tests pdb-redo-unit restr2ccd)
+list(APPEND PDB_REDO_tests pdb-redo-unit restr2ccd shape-fitter)
 if(BUILD_MINIMIZER)
 	list(APPEND PDB_REDO_tests rsr)
 endif()
@@ -34,6 +34,10 @@
 		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Run${PDB_REDO_TEST}.touch
 		COMMAND $<TARGET_FILE:${PDB_REDO_TEST}> -- ${PROJECT_SOURCE_DIR}/test)
 
-	add_test(NAME ${PDB_REDO_TEST}
-		COMMAND $<TARGET_FILE:${PDB_REDO_TEST}> --data-dir ${PROJECT_SOURCE_DIR}/test)
+	if((${PDB_REDO_TEST} STREQUAL "rsr-test" OR ${PDB_REDO_TEST} STREQUAL "shape-fitter-test") AND ("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4}))
+		message(NOTICE "Skipping test ${PDB_REDO_TEST} since CCP4 is not sourced")
+	else()
+		add_test(NAME ${PDB_REDO_TEST}
+			COMMAND $<TARGET_FILE:${PDB_REDO_TEST}> --data-dir ${PROJECT_SOURCE_DIR}/test)
+	endif()
 endforeach()

=== debian/changelog ===
libpdb-redo (3.3.1-1) unstable; urgency=medium

  * New upstream version 3.3.1

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 20 Nov 2025 09:21:42 +0100

=== debian/control ===
--- 
+++ 
@@ -5,15 +5,13 @@
 Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
 Build-Depends:
  debhelper-compat (= 13),
- libcifpp-dev (>= 7),
+ libcifpp-dev (>= 9.0.5),
  cmake,
  libcatch2-dev,
  pkgconf,
  libgsl-dev,
- libboost-regex-dev,
  libeigen3-dev,
  libclipper-dev,
- zlib1g-dev,
  libccp4-dev (>= 6.5.1-5)
 Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/libpdb-redo
